      subroutine denstp (nca,ica,ncb,icb,nt,it,ispt,np,ip,ispp,iadr1,
     *va,vb,istrans)
      parameter(maxsym=8,maxorbcas=16)
      include 'maxorb.prm'
      IMPLICIT REAL*8(A-H,O-X,Z),logical*1(y)
c
c    |-*-*-*-*-*-*-*-|
c    |      b        |
c
      common/dim/ iadri
      common/opt/ihab,calcul
      character*3 calcul
      common/sym/ itsym(maxorb*2),its(maxsym,maxsym),nsym
      common/sy3/itorbi(maxorb),isbrot(maxorb),itorbc(maxorb)
     *,itorbs(maxorb)
      common /orb/ enuc,eref,norb,noca,nocb
     *,iorb(2*maxorb),ninac,nvirt,noca0
      common/orb2/numina(maxorb),numvir(maxorb),iordo(maxorb*2)
     *,iodro(maxorb*2)
     *,numinb(maxorb),numvib(maxorb)
      common/l40/ densa(maxorb,maxorb),densb(maxorb,maxorb)
      dimension ica(maxorbcas),icb(maxorbcas),it(2),ip(2)
      dimension ittemp(maxorb)
      dimension iptemp(maxorb)
      dimension va(iadri)
      dimension vb(iadri)
      common/test/itest(100)
      yw=.false.
c
c-----------------------------------------------------------
c     matrice densite  suppression 1 trou 1 part
c-----------------------------------------------------------
c
      nta=(nt+ispt)/2
      npa=(np+ispp)/2
      ntb=nt-nta
      npb=np-npa
      b0=va(iadr1)
      do 1 i=1,nta
c--------it(i) est le trou supprime
      is1=its(itsym(it(i)),istrans)
      i1=it(i)
      if(yw)write(6,*)'denstp trou a supprime',it(i)
c-----------boucle sur la particule supprimee
      do 2 j=1,npa
      if(is1.ne.itsym(ip(j))) goto 2
      i2=ip(j)
      if(yw)write(6,*)'denstp part a supprimee',ip(j)
c--------------ip(j) est la part supprimee
      do k=1,i-1
         ittemp(k)=it(k)
      enddo
      do k=1,j-1
         iptemp(k)=ip(k)
      enddo
      do k=i+1,nt
         ittemp(k-1)=it(k)
      enddo
      do k=j+1,np
         iptemp(k-1)=ip(k)
      enddo
      call adrdet
     *(nca,ica,ncb,icb,nt-1,ittemp,ispt-1,
     *np-1,iptemp,ispp-1,iadr2,
     *      mhdum,mtdum)
c------------------
c------------------signe
c                  on a supprime le trou i et la part j
c                  on a donc ramene l'el j a la place i
c
c                  l'el a donc saute
c                  - par dessus j-1 part
c                  - par dessus nca el du CAS
c                  - par dessus ninac-ita(i)-(nta-i) occupees
c
c                             occ              CAS         part
c                              i                                j
c                        x x x   x x   x      x x x      x      x
c                              |________________________________|
c                        <---ninac----->      <nca>
c                              <------->
c                              ninac-ita(i)
c                      donc    ninac-ita(i)-(nta-i) electrons
c------------------
c           isgn=1-2*mod(ninac-iordo(it(i))-(nta-i)+nca+j-1,2)
      isgn=1-2*mod(ninac+iodro(it(i))+(nta+i)+nca+j+1,2)
      dd=va(iadr1)*vb(iadr2)*isgn
c     if(i1.eq.1.and.i2.eq.5.or.i2.eq.1.and.i1.eq.5) then
c        write(6,'('' %%%%%E '',2i6,4f10.6,i4)')
c     *   iadr1,iadr2,b(iadr1),b(iadr2),dd,densa(i1,i2),isgn
c     endif
      densa(i1,i2)=densa(i1,i2)+dd
      densa(i2,i1)=densa(i2,i1)+dd
c     if(i1.eq.1.and.i2.eq.5.or.i2.eq.1.and.i1.eq.5) then
c        write(6,'('' %%%%%TP'',2i6,4f10.6)')
c     *   iadr1,iadr2,b(iadr1),b(iadr2),dd,densa(i1,i2)
c     endif
      if(yw)write(6,*)'denstp adresses,int',iadr1,iadr2,isgn
 2    continue
 1    continue
      do 3 i=nta+1,nt
c--------it(i) est le trou supprime
      is1=its(itsym(it(i)),istrans)
      i1=iorb(it(i))
      if(yw)write(6,*)'denstp trou b supprime',it(i)
c-----------boucle sur la particule supprimee
      do 4 j=npa+1,np
      if(is1.ne.itsym(ip(j))) goto 4
      i2=iorb(ip(j))
      if(yw)write(6,*)'denstp part b supprimee',ip(j)
c--------------ip(j) est la part supprimee
      do k=1,i-1
         ittemp(k)=it(k)
      enddo
      do k=1,j-1
         iptemp(k)=ip(k)
      enddo
      do k=i+1,nt
         ittemp(k-1)=it(k)
      enddo
      do k=j+1,np
         iptemp(k-1)=ip(k)
      enddo
      call adrdet
     *(nca,ica,ncb,icb,nt-1,ittemp,ispt+1,
     *np-1,iptemp,ispp+1,iadr2,
     *      mhdum,mtdum)
c------------------
c------------------signe (v. commentaires + haut
c              isgn=1-2*mod(ninac-iordo(mini)-(ntb-i+nta)+ncb+j-npa-1,2)
      isgn=1-2*mod(ninac+iodro(i1)+(ntb+i+nta)+ncb+j+npa+1,2)
      dd=va(iadr1)*vb(iadr2)*isgn
c     if(i1.eq.1.and.i2.eq.5.or.i2.eq.1.and.i1.eq.5) then
c        write(6,'('' %%%%%e '',2i6,4f10.6,i4)')
c     *   iadr1,iadr2,b(iadr1),b(iadr2),dd,densb(i1,i2),isgn
c     endif
      densb(i1,i2)=densb(i1,i2)+dd
      densb(i2,i1)=densb(i2,i1)+dd
c     if(i1.eq.1.and.i2.eq.5.or.i2.eq.1.and.i1.eq.5) then
c        write(6,'('' %%%%%tp'',2i6,4f10.6)')
c     *   iadr1,iadr2,b(iadr1),b(iadr2),dd,densb(i1,i2)
c     endif
      if(yw)write(6,*)'denstp adresses,int',iadr1,iadr2,isgn
 4    continue
 3    continue
      return
      end
